#
#   tags.py  - Python Service Objects
#
#   Author: Thanos Vassilakis thanos@0x01.com
#
#   	Copyright (c) thanos vassilakis 2000,2001, 2002
#
#	This library is free software; you can redistribute it and/or 
#	modify it under the terms of the GNU Lesser General Public License 
#	as published by the Free Software Foundation; either version 2.1 of the 
#	License, or (at your option) any later version.
#
#	This library is distributed in the hope that it will be useful, but 
#	WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
#	or FITNESS FOR A PARTICULAR PURPOSE.  
#	See the GNU Lesser General Public License for more details.
#
#	See terms of license at gnu.org. 
#
#   $Id: tags.py,v 1.8 2002/06/19 15:26:36 thanos Exp $
#
from parser import Tag
from handlers import TemplateHandler
import sys
from cStringIO import StringIO


class Template(Tag, TemplateHandler):
	FIELD_NAME='action'

	def getTemplate(self, req):
		return req.getInput(self.FIELD_NAME, self.getDefaultTemplate(req))
		
	def __call__(self, handler, cdata=''):
#		return self.getTemplate( handler.req())
		return self.parse(handler.req())

	def getDefaultTemplate(self, req):
		default = self.attrs.get('default')
		if not default:
			raise 'please set tag attribute default or override me %s' % self.getDefaultTemplate
		return default


class Exec(Tag):
	def __call__(self, handler, cdata=''):
		if not cdata:
			return ''
		oldout = sys.stdout
		try:
			sys.stdout = StringIO()
			exec cdata
			retval = sys.stdout.getvalue()
			sys.stdout.close()
		finally:
			sys.sdtout = oldout
		return retval	
		
class DataMixin:		
	KEY=None
	def getKey(self, handler): 
		return handler.req().getInput(self.KEY) 

	def getRecord(self, handler, key): pass

	def record(self, handler): 
		key = self.getKey(handler)
		if key:
			scratchKey = (self.DATAMODEL, key)
			record = handler.scratch().get(scratchKey)
			if not record:
				record = self.getRecord(handler, key)
				if record:
					handler.scratch()[scratchKey] = record
			return record
			
		
	def getSelect(self, handler): pass
		
	def getSelection(self, handler, select): pass

	
		
	def selection(self, handler): 
		criteria = self.getSelect(handler)
		scratchKey = (self.DATAMODEL, 'select')
		cursor = handler.scratch().get(scratchKey)
		if not cursor:
			cursor = self.getSelection(handler, criteria)
			if cursor:
				handler.scratch()[scratchKey] = cursor
			return cursor

		
		
		
		
				
class List(Tag):
	PAGEsIZEkEY="pagesize"
	LINEkEY="line"
	PAGEsIZE= 10

	def fetch(self, handler, line, pageSize): 
		" must return an list of  somethings" 
		raise 'define'
		
	
	def __call__(self, handler, cdata):
		records = self.fetch(handler, line=self.getLine(handler), pageSize= self.getPageSize(handler))
		html = ''
		for record   in records:
			html += cdata % self.prepareRow(handler, record)
		return html

	def getPageSize(self, handler):	
		return  int(handler.req().getInput( self.PAGEsIZEkEY, self.getAttrs().get(self.PAGEsIZEkEY, self.PAGEsIZE)))

	def getLine(self, handler):	
		return  int(handler.req().getInput( self.LINEkEY, self.getAttrs().get(self.LINEkEY, '1')))

	def prepareRow(self, handler, record): 
		" must return an dictionary  of  fields that will be merged with the cdata"
		return record
